package com.zipcodewilmington.looplabs;

import java.util.Arrays;

/**
 * Created by leon on 1/29/18.
 * @ATTENTION_TO_STUDENTS You are forbidden from modifying the signature of this class.
 */
public final class IntegerDuplicateDeleter extends DuplicateDeleter<Integer> {
    public IntegerDuplicateDeleter(Integer[] intArray) {
        super(intArray);
    }

    private Integer[] tempArray;
    private int arrCount;
    private int dupCount;
    private Integer dupToIgnore;

    @Override
    public Integer[] removeDuplicates(int maxNumberOfDuplications) {
        Arrays.sort(array);
        tempArray = new Integer[array.length];
        arrCount = 0;
        dupToIgnore = null;
        for (int i = 0; i < array.length; i++) {
            dupCount = 1;

            if (array[i]==dupToIgnore) { continue; }

            doopLoop(i);

            writeToArray(i, dupCount < maxNumberOfDuplications);
        }

        return Arrays.copyOf(tempArray, arrCount);
    }

    private void doopLoop(int i) {
        for (int j = i+1; j < array.length; j++) {
            if (array[i] == array[j]) {
                dupCount++;
            } else {
                break;
            }
        }
    }

    @Override
    public Integer[] removeDuplicatesExactly(int exactNumberOfDuplications) {
        Arrays.sort(array);
        tempArray = new Integer[array.length];
        arrCount = 0;
        dupToIgnore = null;
        for (int i = 0; i < array.length; i++) {
            dupCount = 1;

            if (array[i]==dupToIgnore) { continue; }
            if (i>=1 && array[i]==array[i-1]) {
                tempArray[arrCount] = array[i];
                arrCount++;
                continue;
            }

            doopLoop(i);

            writeToArray(i, dupCount != exactNumberOfDuplications);
        }

        return Arrays.copyOf(tempArray, arrCount);
    }

    private void writeToArray(int i, boolean b) {
        if (b) {
            tempArray[arrCount] = array[i];
            arrCount++;
        } else {
            dupToIgnore = array[i];
        }
    }
}
