package com.zipcodewilmington.looplabs;

import java.util.Arrays;

/**
 * Created by leon on 1/28/18.
 * @ATTENTION_TO_STUDENTS You are forbidden from modifying the signature of this class.
 */
public final class StringDuplicateDeleter extends DuplicateDeleter<String> {
    public StringDuplicateDeleter(String[] intArray) {
        super(intArray);
    }

    private String[] tempArray;
    private int arrCount;
    private int dupCount;
    private String dupToIgnore;

    @Override
    public String[] removeDuplicates(int maxNumberOfDuplications) {
        Arrays.sort(array);
        tempArray = new String[array.length];
        arrCount = 0;
        dupToIgnore = null;
        for (int i = 0; i < array.length; i++) {
            dupCount = 1;

            // IGNORE AFTER FIRST OCCURRENCE
            if (array[i].equals(dupToIgnore)) { continue; }

            doopLoop(i);

            writeToArray(i, dupCount < maxNumberOfDuplications);
        }

        return Arrays.copyOf(tempArray, arrCount);
    }

    private void doopLoop(int i) {
        for (int j = i+1; j < array.length; j++) {
            if (array[i].equals(array[j])) {
                dupCount++;
            } else {
                break;
            }
        }
    }

    @Override
    public String[] removeDuplicatesExactly(int exactNumberOfDuplications) {
        Arrays.sort(array);
        tempArray = new String[array.length];
        arrCount = 0;
        dupToIgnore = null;
        for (int i = 0; i < array.length; i++) {
            dupCount = 1;

            // IGNORE OR INCLUDE AFTER FIRST OCCURRENCE
            if (array[i].equals(dupToIgnore)) { continue; }
            if (i>0 && array[i].equals(array[i - 1])) {
                tempArray[arrCount] = array[i];
                arrCount++;
                continue;
            }

            doopLoop(i);

            writeToArray(i, dupCount != exactNumberOfDuplications);
        }

        return Arrays.copyOf(tempArray, arrCount);
    }

    private void writeToArray(int i, boolean b) {
        if (b) {
            tempArray[arrCount] = array[i];
            arrCount++;
        } else {
            dupToIgnore = array[i];
        }
    }
}
